code	segment
assume	cs:code,ds:code,es:code,ss:code
	org	0
befehl	equ	2
status	equ	3
anz_ger	equ	13
wechsel	equ	14
end_adr	equ	14
p_adr	equ	14
anzahl	equ	18
bpb_adr	equ	18
sektor	equ	20
ger_bez	equ	22
	dw	-1,-1
	dw	0
	dw	offset  strat
	dw	offset  intr
	db	1,0,0,0,0,0,0,0
db_ptr	dw	(?),(?)
rd_seg	dw	(?)
bpb_ptr	dw	offset  bpb,(?)
bootsek	db	3 dup (0)
	db	"MITI 1.0"
bpb	dw	512
	db	1
	dw	1
	db	1
	dw	64
	dw	256
	db	0FEh
	dw	1
volname	db	"RAMDISK    "
	db	8
strat	proc	far
	mov	cs:db_ptr,bx
	mov	cs:db_ptr+2,es
	ret
strat	endp
;-----------------------------------------------------------------------
intr	proc	far
	push	ax
	push	bx
	push	cx
	push	dx
	push	di
	push	si
	push	bp
	push	ds
	push	es
	pushf
	push	cs
	pop	ds
	les	di,dword ptr db_ptr
	mov	bl,es:[di+befehl]
	cmp	bl,1
	jnz	lo1
	mov	byte ptr es:[di+wechsel],1
lo1:	cmp	bl,2
	jnz	lo2
	mov	word ptr es:[di+bpb_adr],offset bpb
	mov	word ptr es:[di+bpb_adr+2],ds
lo2:	cmp	bl,4
	jz	lesen
	cmp	bl,8
	jz	write
	cmp	bl,9
	jz	write
	cmp	bl,0
	jz	init
irqend:	push	cs
	pop	ds
	les	di,dword ptr db_ptr
	mov	ax,0100h
	mov	es:[di+status],ax
	popf
	pop	es
	pop	ds
	pop	bp
	pop	si
	pop	di
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	ret
intr	endp
;-----------------------------------------------------------------------
write	proc	near
	xor	bp,bp
	jmp	short move
write	endp
;-----------------------------------------------------------------------
lesen	proc	near
	mov	bp,1
lesen	endp
move	proc	near
	mov	bx,es:[di+anzahl]
	mov	dx,es:[di+sektor]
	les	di,es:[di+p_adr]
move_1:	or	bx,bx
	je	irqend
	mov	ax,dx
	mov	cl,5
	shl	ax,cl
	add	ax,cs:rd_seg
	mov	ds,ax
	xor	si,si
	mov	ax,bx
	cmp	ax,128
	jbe	move_2
	mov	ax,128
move_2:	sub	bx,ax
	add	dx,ax
	mov	ch,al
	xor	cl,cl
	or	bp,bp
	jne	move_3
	mov	ax,es
	push	ds
	pop	es
	mov	ds,ax
	xchg	si,di
move_3:	rep	movsw
	or	bp,bp
	jne	move_1
	mov	ax,es
	push	ds
	pop	es
	mov	ds,ax
	xchg	si,di
	jmp	short move_1
move	endp

ramdisk	equ	this byte

;-----------------------------------------------------------------------
init	proc	near
	mov	ah,30h
	int	21h
	cmp	al,3
	jb	prinm
	mov	al,es:[di+ger_bez]
	add	al,"A"
	mov	im_ger,al
prinm:	mov	dx,offset initm
	mov	ah,9
	int	21h
	mov	word ptr es:[di+end_adr],offset ramdisk
	mov	ax,cs
	mov	es:[di+end_adr+2],ax
	mov	byte ptr es:[di+anz_ger],1
	mov	word ptr es:[di+bpb_adr],offset bpb_ptr
	mov	es:[di+bpb_adr+2],ds
	mov	ax,0c000h
	mov	rd_seg,ax
	mov	es,ax
	xor	di,di
	mov	si,offset bootsek
	mov	cx,15
	repz	cmpsw
	jz	noform
	mov	es,ax
	xor	di,di
	mov	si,offset bootsek
	mov	cx,15
	rep	movsw
	mov	di,512
	mov	al,0FEh
	stosb
	mov	ax,0FFFFH
	stosw
	mov	cx,236
	inc	ax
	rep	stosw
	mov	di,1024
	mov	si,offset volname
	mov	cx,6
	rep	movsw
	mov	cx,1017
	xor	ax,ax
	rep	stosw
	mov	dx,offset format
	mov	ah,9
	int	21h
noform:	jmp	irqend
init	endp
;-----------------------------------------------------------------------

initm	db	"128 KB RAMDISK als Laufwerk "
im_ger	db	"?"
	db	": installiert.",13,10,"$"
format	db	"128 KB RAMDISK formatiert.",13,10,"$"

code	ends
	end
