;UMB - treiber fr den Speicherbereich C0000-DFFFF

;assemblieren mit A86, und entstehende .BIN-datei einfach in .SYS umbenennen.

	org 0
start	dw -1,-1
        dw 8000h		;zeichentreiber
stptr   dw offset strat
inptr   dw offset intr
        db "UMBXXXX0"		;giebt vor, ein XMS-treiber zu sein
datofs	dw 0
datseg	dw 0
belegt	db 0

multi	proc	near		;Multiplexereinsprung
	cmp	ax,4300h	;XMS-Identifizierung ?
	jnz	lo1		;nein - lo1
	mov	al,80h		;ja !
	iret			;fertig
lo1:	cmp	ax,4310h	;Adressbergabe ?
	jnz	muxjmp		;nein - weiter
	push	cs		;ja !
	pop	es
	mov	bx,offset haupt
	iret
muxjmp:	jmp	0000:0000	;Sprungadresse wird noch gendert
multi	endp

haupt	proc	near
        cmp     ah,16		;UMB allokieren ?
        jz      allok		;ja !
        xor	ax,ax		;umbekannte Fungtion !
	mov	bl,80h
hint:	retf			;aus Platzgrnden bernimmt
				;dieses RETF die Aufgabe der Strategie,-
				;und Interruptroutine
allok:  cmp     b[cs:belegt],1	;schon allokiert ?
        jz      allok2		;ja - Fehler
        cmp     dx,8193		;wieviel angefordert ?
        jb      allok1		;genug Speicher da - mem vergeben
        xor     ax,ax		;zuviel gefordert
        mov     dx,8192		;soviel ist da !
        mov     bx,0b0h		;fehlernummer
        retf			;ende
allok1: 


	push	es
	mov	ax,0
	mov	es,ax

	mov	ax,cs:[muxjmp+3]
	mov	es:[0beh],ax
	mov	ax,cs:[muxjmp+1]	
	mov	es:[0bch],ax
	pop	es


	mov     ax,1		;OK
        mov     [cs:belegt],al	;mem als belegt markieren
        mov     bx,0c000h	;Adresse bergeben
        retf			;ende
allok2: xor     ax,ax		;mem schon allokiert
        mov     dx,ax		;fehler
        mov     bx,0b1h		;fehlernummer
        retf			;ende
haupt	endp
ende:	;bis hierher geht der eigendliche treiber, der dann im Speicher steht
	db 13,10,"Copyright 07.05.1996 by Stefan Berndt",13,10
	db "Hinweis : dieser Treiber ist nur fr aufgerstete CM1910 geschrieben !",13,10
meldung db "UMB-Treiber 2.0 installiert.",13,10,"$"
numberr	db "Kein Zusatzspeicher vorhanden, kein UMB mglich.",13,10,"$"

intr    proc far                ;nur zur initialisierung !
        push ax                
        push bx
        push cx
        push dx
        push di
        push si
        push bp
        push ds
        push es
        pushf
        push cs
        pop  ds

	mov	ax,0c000h		;Speichertest
	mov	es,ax			;(nur eine Stichprobe !)
	xor	ax,ax
	mov	[es:0],ax
	cmp	[es:0],ax
	jnz	noumb
	mov	ax,0ffffh
	mov	[es:0],ax
	cmp	[es:0],ax
	jnz	noumb
	mov	bx,cs:datofs
	mov	es,cs:datseg

	mov	ax,0	;treiberende an dos bergeben
	mov	[es:bx + 0eh],ax
	mov	[es:bx + 10h],cs

	mov	ax,352fh		;multiplex-JMP verndern
	int	21h
	mov	[muxjmp+1],bx
	mov	[muxjmp+3],es

	mov	ax,0c000h
	mov	ds,ax
	mov	ax,252fh		;IRQ-vector fr mux ndern
	mov	dx,offset multi		
	int	21h

	mov	ax,0c000h
	mov	es,ax
	mov	di,0
	push	cs
	pop	ds
copy:	mov	al,ds:[di]
	mov	es:[di],al
	inc	di
	cmp	di,ende+5
	jne	copy

	mov	dx,offset meldung	;Meldung ausgeben
	mov	ah,9
	int	21h
	jmp	inord

noumb:	mov	dx,offset numberr	;fehlermeldung
	mov	ah,9
	int	21h

	mov	bx,cs:datofs		;kein Treiber!
	mov	es,cs:datseg
	mov	ax,offset start
	mov	[es:bx + 0eh],ax
	mov	[es:bx + 10h],cs

	
inord:	mov	ax,offset hint		;interrupt und strategie
	mov	inptr,ax		;nicht mehr nutzen
	mov	stptr,ax
	popf				;ende
        pop  es
        pop  ds
        pop  bp
        pop  si
        pop  di
        pop  dx
        pop  cx
        pop  bx
        pop  ax
	retf
intr    endp

strat   proc far			;strategieroutine nur zur 
        mov  cs:datofs,bx		;installation
        mov  cs:datseg,es
        retf
strat   endp
